﻿//Script Copyright 2012 by Richard Y. Kain. I am indebted to others who made predecessor
//scripts that did not have varying copy sizes and varying copy spacing, which I added by
//rewriting portions and resturcturing the information transferred among the two scripts.
//This script for Photoshop CS6 displays the dialog window and eventually calls deco fill to
//execute the script mentioned below.
//The major feture is that the sizes of the pattern can vary progressively along the path, and
//the spacing of the copies can be specified. This script invokes the script "Varying Path and Spacing"
//that is called from the fill dialog to actually render the pattern copies.
//The scripts should be located in the directory \presets\deco in the CS6 program files context.
//This script should be invoked from Photoshop through the File>Scripts path

#target photoshop
app.bringToFront();
main();
function main(){
var updated=false;
if(!documents.length) return;

//The following code (by someone else) constructs an alphabetic list of the patterns known to the fill dialog.
var file = File(Folder.temp +"/deco.pat"); 
if(file.exists) file.remove(); 
savePatterns( file );
  file.open("r");
  file.encoding = 'BINARY';
  var str = file.read();
  file.close();
  var patterns=[];
  var rex = /(\x00\w|\x00\d)(\x00\-|\x00\w|\x00\s|\x00\d)+\x00\x00\$[-a-z\d]+/g;
  while ((result = rex.exec(str)) != null) { 
	  var sp = result[0].toString().replace(/\x00/g, '').split('$');
	  var X = readInt16(str,(result.index+(result[0].length)+22));
	  var Y = readInt16(str,(result.index+(result[0].length)+18));
    patterns.push([[sp[0]],[sp[1]],[X],[Y]]);      
      }
patterns=ReturnUniqueSortedList(patterns);
file.remove();

//The following code (by someone else, slightly modified by me) displays the dialog about the path fill
var win = new Window( 'dialog', 'Path Fill' ); 
g = win.graphics;
var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.99, 0.99, 0.99, 1]);
g.backgroundColor = myBrush;
win.p1= win.add("panel", undefined, undefined, {borderStyle:"black"}); 
win.g1 = win.p1.add('group');
win.g1.orientation = "row";
win.title = win.g1.add('statictext',undefined,'Path Fill');
win.title.alignment="fill";
var g = win.title.graphics;
g.font = ScriptUI.newFont("Georgia","BOLDITALIC",22);
win.g5 =win.p1.add('group');
win.g5.orientation = "row";
win.g5.alignment='fill';
win.g5.spacing=10;
win.g5.st1 = win.g5.add('statictext',undefined,'Spacing of pattern copies (as a percentage of its width): ');
win.g5.st1.preferredSize=[340,20];
win.g5.et1 = win.g5.add('edittext',undefined,'50');
win.g5.et1.preferredSize=[50,20];
win.g5.et1.onChanging = function() { 
  if (this.text.match(/[^\-\.\d]/)) { 
    this.text = this.text.replace(/[^\-\.\d]/g, ''); 
  } 
};
win.g8 =win.p1.add('group');
win.g8.orientation = "row";
win.g8.alignment='fill';
win.g8.spacing=10;
win.g8.st1 = win.g8.add('statictext',undefined,'Final pattern size (as a percentage): ');
win.g8.st1.preferredSize=[340,20];
win.g8.et1 = win.g8.add('edittext',undefined,'10');
win.g8.et1.preferredSize=[50,20];
win.g8.et1.onChanging = function() { 
  if (this.text.match(/[^\-\.\d]/)) { 
    this.text = this.text.replace(/[^\-\.\d]/g, ''); 
  } 
};
win.g10 =win.p1.add('group');
win.g10.orientation = "row";
win.g10.alignment='fill';
win.g10.st1 = win.g10.add('statictext',undefined,'Please select Pattern:');
win.g10.st1.preferredSize=[340,20];
win.g10.dd1 = win.g10.add('dropdownlist');
for(var p in patterns){win.g10.dd1.add('item',patterns[p][0]);}
win.g10.dd1.selection=0; 
win.g10.dd1.onChange = function(){
var str = patterns[win.g10.dd1.selection.index][0].toString() + " ( X = " ;
str += Number(patterns[win.g10.dd1.selection.index][2]) + " Y = ";
str += Number(patterns[win.g10.dd1.selection.index][3]) + ")";
//win.g10.dd1.helpTip = str;
}
win.g10.dd1.onChange();
win.g15 =win.p1.add('group');
win.g15.orientation = "row";
win.g15.alignment='fill';
var Blend = ['Normal','Dissolve','-','Darken','Multiply','Color Burn','Linear Burn','Darker Color','-','Lighten','Screen','Color Dodge',
    'Linear Dodge (Add)','Lighter Color','-','Overlay','Soft Light','Hard Light','Vivid Light','Linear Light', 'Pin Light','Hard Mix','-','Difference', 'Exclusion',
    'Subtract','Divide','-','Hue','Saturation','Color','Luminosity'];
var bMode=['Nrml','Dslv','-','Drkn','Mltp','CBrn','linearBurn','darkerColor','-','Lghn', 'Scrn',
'CDdg','linearDodge','lighterColor','-','Ovrl','SftL','HrdL','vividLight','linearLight','pinLight','hardMix','-',
'Dfrn','Xclu','blendSubtraction','blendDivide','-','H   ','Strt','Clr ','Lmns'];
win.g15.st1 = win.g15.add('statictext',undefined,'Blend Mode:');
win.g15.st1.preferredSize=[340,20];
win.g15.dd1 = win.g15.add('dropdownlist',undefined,Blend);
win.g15.dd1.selection=0;
win.g20 =win.p1.add('group');
win.g20.orientation = "row";
win.g20.alignment='fill';
win.g20.st1 = win.g20.add('statictext',undefined,'Opacity:');
win.g20.st1.preferredSize=[340,20];
win.g20.et1 = win.g20.add('edittext',undefined,'100');
win.g20.et1.preferredSize=[50,20];
win.g20.et1.onChanging = function() { 
  if (this.text.match(/[^\-\.\d]/)) { 
    this.text = this.text.replace(/[^\-\.\d]/g, ''); 
  } 
};
var pictureFlag = true          //flag about whether you choose to select patterns by name or by picture
win.g100 =win.p1.add('group');
win.g100.orientation = "row";
win.g100.alignment='center';
win.g100.bu1 = win.g100.add('button',undefined,'Paint pattern copies');
win.g100.bu1.preferredSize=[150,30];
win.g100.bu3 = win.g100.add('button',undefined,'See pattern pictures');
win.g100.bu3.preferredSize=[150,30];
win.g100.bu2 = win.g100.add('button',undefined,'Close');
win.g100.bu2.onClick=function(){
    win.close(0);
}

win.g100.bu2.preferredSize=[150,30];

//Control goes here if the pattern was chosen by name and the button to do it was clicked
win.g100.bu1.onClick=function(){
if(win.g5.et1.text == ''){
    alert("Your spacing cannot be blank");
    return;
    }
if(isNaN(Number(win.g5.et1.text) )){
    alert("Your entry for the spacing is not a number");
    return;
    }
if (Number(win.g5.et1.text)<10){
    alert("Your spacing must be at least 10%");
    return;
    }
if(win.g8.et1.text == ''){
    alert("Your final size specification cannot be blank");
    return;
    }
if(isNaN(Number(win.g8.et1.text) )){
    alert("Your entry for the final size is not a number");
    return;
    }
win.close(0);
pictureFlag = false;

if (updated==true){
var idslct = charIDToTypeID( "slct" );
    var desc4 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref4 = new ActionReference();
        var idHstS = charIDToTypeID( "HstS" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idPrvs = charIDToTypeID( "Prvs" );
        ref4.putEnumerated( idHstS, idOrdn, idPrvs );
    desc4.putReference( idnull, ref4 );
executeAction( idslct, desc4, DialogModes.NO );
}
updated=true;



doit(pictureFlag);
app.refresh()
}       //end finction for using the patterns by name

//The followong code is invokied if the user wishes to see the patterns in the fil dialog box before tracing the path
win.g100.bu3.onClick=function(){
 if(win.g5.et1.text == ''){
    alert("Your spacing cannot be blank");
    return;
    }
if(isNaN(Number(win.g5.et1.text) )){
    alert("Your entry for the spacing is not a number");
    return;
    }
if(win.g8.et1.text == ''){
    alert("Your final size specification cannot be blank");
    return;
    }
if(isNaN(Number(win.g8.et1.text) )){
    alert("Your entry for the final size is not a number");
    return;
    }

pictureFlag = true;
win.close(0);
doit(pictureFlag);
}       //end finction for using the patterns by pictures - through the fill dialog box

//This function traces the path and creates a listing of points along the path
function doit(useFillBoxFlag) {
// Save the current preferences
var startRulerUnits = app.preferences.rulerUnits;
var startTypeUnits = app.preferences.typeUnits;
var startDisplayDialogs = app.displayDialogs;
// Set Adobe Photoshop CS6 to use pixels and display no dialogs
app.preferences.rulerUnits = Units.PIXELS;
app.preferences.typeUnits = TypeUnits.PIXELS;
//app.displayDialogs = DialogModes.NO;

var activePath=activePathIndex()
if (activePath=-1)activePath=0;
myPath=activeDocument.pathItems[activePathIndex()].subPathItems[0]; //I'm just calculating the first subpath of the active path

var scriptEndSize = Number(win.g8.et1.text);   //FInal pattern size ad a percentage
var spacing =Number(win.g5.et1.text)
//*Number(patterns[win.g10.dd1.selection.index][2])/100;    // Initial Spacing of points in pixels

spacedPoints= new Array;    //The position of each of the equally spaced points
rotations = new Array;       //The rotation of each of the equally spaced points
copysizes = new Array;      //The sizes of the copies to be places at the points along the path

//accuracy of calculation... how many straight line segments each curved segment is split into.
//Note that the granularity is set so that there are about 800 points along the total path, which
//prevents the arrays that are put into the global environment from overflowing.
var granularity = Math.floor(800/myPath.pathPoints.length);


var results = new Array; //points of the straight line segment.... these aren't evenly spaced.
var pointCount=myPath.pathPoints.length-1;

//Approximate Path by dividing into straight line segments
var d = myPath.pathPoints[0].anchor;
for(var i = 0; i< pointCount; i++)
{
    var a = d
    var b = myPath.pathPoints[i].leftDirection;
    var c = myPath.pathPoints[i+1].rightDirection;
    var d = myPath.pathPoints[i+1].anchor;   
    for (var j =0; j < granularity; j++)
    {
        var t = j/granularity;
        results[i*granularity + j] = bezier (a, b, c, d, t);
    }
}

// Calculate the last path segment if the path is closed.... same code as above
if(myPath.closed==true){
    var a = myPath.pathPoints[pointCount].anchor
    var b = myPath.pathPoints[pointCount].leftDirection;
    var c = myPath.pathPoints[0].rightDirection;
    var d = myPath.pathPoints[0].anchor;   
    for (var j =0; j < granularity; j++)
    {
        var t = j/granularity;
        results[pointCount*granularity + j] = bezier (a, b, c, d, t);
    }
}

//Calculate the length of the curve up to each point
var segmentLength= new Array;
segmentLength[0]=0;
var totalLength=segmentLength[0];
for(var i = 0; i < results.length-1; i++)
{
    segmentLength[i+1]= segmentLength[i]+Math.sqrt(Math.pow(results[i][0]-results[i+1][0],2) + Math.pow(results[i][1]-results[i+1][1],2));
}

//set temp vars in memory
$.setenv("DECOpoints","var points = ["+results.toString()+"];");
$.setenv("DECOendsize","var endsize = "+scriptEndSize+";");
$.setenv("DECOlengths","var lengths = ["+segmentLength.toString()+"];");
$.setenv("DECOspacing","var spacing = "+spacing+";");
$.setenv("DECOpathclosed","var pathclosed = "+myPath.closed+";");

// Reset the application preferences
app.preferences.rulerUnits = startRulerUnits;
app.preferences.typeUnits = startTypeUnits;
app.displayDialogs = startDisplayDialogs;
//call fill menu
var Name = patterns[win.g10.dd1.selection.index][0];
var PatID = patterns[win.g10.dd1.selection.index][1];
var BMODE = bMode[win.g15.dd1.selection.index];
var Opacity = Number(win.g20.et1.text);
if(Opacity > 100) Opacity = 100;
if(Opacity < 0) Opacity = 0;

try{
decoFill(Name,PatID,BMODE,Opacity,useFillBoxFlag);
}catch(e){}
}
win.center();
win.show();
}
function bezier(a,b,c,d,t)
{
    var ab,bc,cd,abbc,bccd;
    ab = lerp(a,b,t);
    bc = lerp(b,c,t);
    cd = lerp(c,d,t);
    abbc = lerp(ab,bc,t);
    bccd = lerp(bc,cd,t);
    return lerp(abbc,bccd,t);
}

function lerp(a,b,t) 
{
    var x = a[0] + (b[0]-a[0])*t;
    var y = a[1] + (b[1]-a[1])*t;
    return [x,y];    
}
function readByte(str, ofs) {
    return str.charCodeAt(ofs);
  }
function readInt16(str, ofs) {
    return (readByte(str, ofs) << 8) + readByte(str, ofs+1);
  }
function activePathIndex(){// returns -1 if no path active/selective
   try{
      var ref = new ActionReference();
      ref.putEnumerated( charIDToTypeID("Dcmn"), charIDToTypeID("Ordn"), charIDToTypeID("Trgt") );
      var desc = executeActionGet( ref );
      return  desc.getInteger(charIDToTypeID("TrgP" ));
   }catch(e){}
};
 function decoFill(Name,PatID,BMODE,Opacity,useFillBoxFlag) {

         if(BMODE.length> 4) {
        var blendMode ="stringIDToTypeID(BMODE);";
        }else{
            var blendMode = "charIDToTypeID(BMODE);";
            }
    var desc16 = new ActionDescriptor();
    desc16.putEnumerated( charIDToTypeID('Usng'), charIDToTypeID('FlCn'), charIDToTypeID('Ptrn') );
        var desc17 = new ActionDescriptor();
        desc17.putString( charIDToTypeID('Nm  '), Name.toString());
        desc17.putString( charIDToTypeID('Idnt'), PatID.toString());
    desc16.putObject( charIDToTypeID('Ptrn'), charIDToTypeID('Ptrn'), desc17 );
    desc16.putPath( stringIDToTypeID('decoScriptFile'), new File( app.path +"/Presets/Deco/Varying Path and Spacing.jsx" ) );
    desc16.putUnitDouble( charIDToTypeID('Opct'), charIDToTypeID('#Prc'), Number(Opacity) );
    desc16.putEnumerated( charIDToTypeID('Md  '), charIDToTypeID('BlnM'), eval(blendMode));
    try{
        if (useFillBoxFlag) {
    executeAction( charIDToTypeID('Fl  '), desc16, DialogModes.ALL )}   //Show the fill dialog box on the way to the path rendering
        else {
    executeAction( charIDToTypeID('Fl  '), desc16, DialogModes.NO )}    //Skip the fill box because the pattern was selected by name,
    }catch(e){return;}
};

//The rest of this is fuc\nctions supporting listing pattern names
function savePatterns( file ) { 
    var desc = new ActionDescriptor(); 
    desc.putPath( charIDToTypeID( "null" ), new File(file) ); 
        var ref = new ActionReference(); 
        ref.putProperty( charIDToTypeID( "Prpr" ), charIDToTypeID( "Ptrn" ) ); 
        ref.putEnumerated( charIDToTypeID( "capp" ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) ); 
    desc.putReference( charIDToTypeID( "T   " ), ref ); 
executeAction( charIDToTypeID( "setd" ), desc, DialogModes.NO ); 
}; 

//this was written by someone else - note that this method of finding duplicates eliminates long names that differ far to the right
function ReturnUniqueSortedList(ArrayName){
var unduped = new Object;
for (var i = 0; i < ArrayName.length; i++) {   
unduped[ArrayName[i]] = ArrayName[i];
}
var uniques = new Array;for (var k in unduped) {
   uniques.push(unduped[k]);}
return uniques.sort();
}