﻿//Script Copyright 2012 by Richard Y. Kain
//Script for Photoshop CS6 that actually places copies of a pattern as specified by the user from
//the script "Specify Varying Sizes along Path." This script is invoked from that one to be executed
//after the user has specified the pattern to be copied, either by name or by looking at the patterns
//from the fill dialog box. The script file should be located in the directory \presets\deco witin the
//Adobe CS6 program files.

//Get information about the path from the environmental variables that were ser by the Specify script
eval($.getenv("DECOpoints"));
//eval($.getenv("DECOrotations"));
eval($.getenv("DECOendsize"));
//eval($.getenv("DECOcopysizes"));
eval($.getenv("DECOspacing"));
eval($.getenv("DECOlengths"));
eval($.getenv("DECOpathclosed"));

var pattern = RenderAPI.getParameter(kpsPattern);       //get pattern information 

var patternSize = pattern.getParameter(kpsSize)

//Points aren't equally distributed, This makes an array of points spaced along the path according to the changing sizes

var inspacing = spacing*patternSize.x/100
var scriptEndSize = endsize
//set up for closed paths
if(pathclosed==true){
    inspacing = fullLength / Math.round(fullLength/inspacing)
    scriptEndSize = 100
    }
    
    //setup for the loop to find where the pattern copies go
var count = 0;
var totalEq = 0;            //This is the actual position measured along the path 
var fullLength=lengths[lengths.length-1]


//adjust spacing to compensate for smaller next copy - so copies line up when spacing is 100%
inspacing = inspacing*200*fullLength/(200*fullLength+(100-scriptEndSize)*patternSize.x)

while((totalEq < fullLength)){
    while(totalEq>= lengths[count+1])   //count along the path to the point where the naxt copy shold be placed
    {
        count++;             
    }

    while(lengths[count+1]>=totalEq && totalEq < fullLength)
    {   

        var dcount = count * 2      //index to the x coordiinate of the point
        var t = (totalEq-lengths[count]) / (lengths[count+1]-lengths[count])
         var x = points[dcount] + (points[dcount+2]-points[dcount])*t
        var y = points[dcount+1] + (points[dcount+3] - points[dcount+1])*t
        var rotation= Math.atan2 ((points[dcount+3]-points[dcount+1]),(points[dcount+2]-points[dcount]))*(180/Math.PI);
        if(rotation<0)rotation+=360
        copysize = (100-scriptEndSize)*(fullLength - lengths[count])/fullLength + scriptEndSize
        totalEq+=inspacing*copysize/100;          //counting position along the path to the next point
 
        //render this copy of the pattern
            RenderAPI.pushMatrix() ;  
 

            RenderAPI.translate(x, y);
            RenderAPI.rotate(rotation);
            RenderAPI.scale(copysize/100)
            pattern.render(RenderAPI);
            RenderAPI.popMatrix();
    }
}


//Housecleaning
$.setenv("DECOpoints","");
$.setenv("DECOendsize","");
$.setenv("DECOspacing","");
$.setenv("DECOlengths","");
$.setenv("DECOpathclosed","");
